/***************************************************************************
                          msg.c  -  description
                             -------------------
    begin                : Thu Jun 6 2002
    copyright            : (C) 2002 by root
    email                : root@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <curses.h>
#include "head.h"
#include "structs.h"
#include <string.h>

void addMsg(char *msg,u8 options)
{
	u8 i;
	for(i=0;i<antMsg;i++) {
		memcpy(&totalMsg[antMsg-i],&totalMsg[antMsg-1-i],sizeof(struct _total));
	}
	if(strlen(name)>0&&options==0)
		sprintf(totalMsg[0].context,"%s: %s",name,msg);
	else
		sprintf(totalMsg[0].context,"%s",msg);
	if(antMsg<49)
		antMsg++;
}
u8 findName(char *msg)
{
	u8 i;
	for(i=0;i<strlen(msg);i++)
		if(strncmp(&msg[i],": ",2)==0)
			break;
	if(i<strlen(msg))
		return i+2;
	else
		return 0;
}
void printName(char *msg,u8 pos)
{
	u8 i;
	move(pos,1);
	if(strncmp(msg,name,strlen(name))==0&&strlen(name)>0)
		attrset(COLOR_PAIR(NAME));
	else if(strncmp(msg,"system",strlen(name))==0)
		attrset(COLOR_PAIR(SYSTEM));
	else
		attrset(COLOR_PAIR(USERS));
	for(i=0;i<findName(msg);i++)
		printw("%c",msg[i]);
	attrset(A_NORMAL);
}
void printRest(char *msg,u8 pos)
{
	u8 i,y,x;
	attrset(COLOR_PAIR(TEXT));
	for(i=findName(msg),y=pos,x=findName(msg)+1;i<strlen(msg);i++,x++) {
		if(x==COLS-1) {
			y++;
			x=findName(msg)+1;
		}
		switch(msg[i])
		{
			case '\n':
				y++;
				x=findName(msg); // not +1 fordi den bliver +1 i slutningen at for
				break;
			default:
				mvprintw(y,x,"%c",msg[i]);
				break;
		}
	}
	attrset(A_NORMAL);
}
int getLineSize(int f)
{
	u8 i,e,d;
	for(i=0,e=0,d=findName(totalMsg[f].context)+1;i<strlen(totalMsg[f].context);i++,d++) {
		if(d==COLS-1) {
			d=findName(totalMsg[f].context)+1;
			e++;
		} else if(totalMsg[f].context[i]=='\n') {
			e++;
			d=findName(totalMsg[f].context)+1;
		}
	}
	return e;
}
void printMsg(u8 offset)
{
	int i,e;
	void clearSpace();
	clearSpace();
	for(e=0,i=(LINES-4)-offset;e<antMsg&&i>0;e++,i--) {
		i=i-getLineSize(e);
		if(i<=0)
			break;
		//i=i-((int)strlen(totalMsg[e].context)/COLS);
		printName(totalMsg[e].context,i);
		printRest(totalMsg[e].context,i);
	}
	move(currentPos.y,currentPos.x);
}


